summaryrefslogtreecommitdiff
path: root/src/share/common
blob: d286145f31481f9b5bf806466979f4e08cdd073e (plain)
  1. # -*-shell-script-*-
  2. # This should be sourced by bash (though we welcome changes to make it POSIX sh compliant)
  3. # Shared sh functions for the monkeysphere
  4. #
  5. # Written by
  6. # Jameson Rollins <jrollins@finestructure.net>
  7. # Jamie McClelland <jm@mayfirst.org>
  8. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  9. #
  10. # Copyright 2008-2009, released under the GPL, version 3 or later
  11. # all-caps variables are meant to be user supplied (ie. from config
  12. # file) and are considered global
  13. ########################################################################
  14. ### UTILITY FUNCTIONS
  15. # output version info
  16. version() {
  17. cat "${SYSSHAREDIR}/VERSION"
  18. }
  19. # failure function. exits with code 255, unless specified otherwise.
  20. failure() {
  21. [ "$1" ] && echo "$1" >&2
  22. exit ${2:-'255'}
  23. }
  24. # write output to stderr based on specified LOG_LEVEL the first
  25. # parameter is the priority of the output, and everything else is what
  26. # is echoed to stderr. If there is nothing else, then output comes
  27. # from stdin, and is not prefaced by log prefix.
  28. log() {
  29. local priority
  30. local level
  31. local output
  32. local alllevels
  33. local found=
  34. # don't include SILENT in alllevels: it's handled separately
  35. # list in decreasing verbosity (all caps).
  36. # separate with $IFS explicitly, since we do some fancy footwork
  37. # elsewhere.
  38. alllevels="DEBUG${IFS}VERBOSE${IFS}INFO${IFS}ERROR"
  39. # translate lowers to uppers in global log level
  40. LOG_LEVEL=$(echo "$LOG_LEVEL" | tr "[:lower:]" "[:upper:]")
  41. # just go ahead and return if the log level is silent
  42. if [ "$LOG_LEVEL" = 'SILENT' ] ; then
  43. return
  44. fi
  45. for level in $alllevels ; do
  46. if [ "$LOG_LEVEL" = "$level" ] ; then
  47. found=true
  48. fi
  49. done
  50. if [ -z "$found" ] ; then
  51. # default to INFO:
  52. LOG_LEVEL=INFO
  53. fi
  54. # get priority from first parameter, translating all lower to
  55. # uppers
  56. priority=$(echo "$1" | tr "[:lower:]" "[:upper:]")
  57. shift
  58. # scan over available levels
  59. for level in $alllevels ; do
  60. # output if the log level matches, set output to true
  61. # this will output for all subsequent loops as well.
  62. if [ "$LOG_LEVEL" = "$level" ] ; then
  63. output=true
  64. fi
  65. if [ "$priority" = "$level" -a "$output" = 'true' ] ; then
  66. if [ "$1" ] ; then
  67. echo "$@"
  68. else
  69. cat
  70. fi | sed 's/^/'"${LOG_PREFIX}"'/' >&2
  71. fi
  72. done
  73. }
  74. # run command as monkeysphere user
  75. su_monkeysphere_user() {
  76. # our main goal here is to run the given command as the the
  77. # monkeysphere user, but without prompting for any sort of
  78. # authentication. If this is not possible, we should just fail.
  79. # FIXME: our current implementation is overly restrictive, because
  80. # there may be some su PAM configurations that would allow su
  81. # "$MONKEYSPHERE_USER" -c "$@" to Just Work without prompting,
  82. # allowing specific users to invoke commands which make use of
  83. # this user.
  84. # chpst (from runit) would be nice to use, but we don't want to
  85. # introduce an extra dependency just for this. This may be a
  86. # candidate for re-factoring if we switch implementation languages.
  87. case $(id -un) in
  88. # if monkeysphere user, run the command under bash
  89. "$MONKEYSPHERE_USER")
  90. bash -c "$*"
  91. ;;
  92. # if root, su command as monkeysphere user
  93. 'root')
  94. su "$MONKEYSPHERE_USER" -c "$*"
  95. ;;
  96. # otherwise, fail
  97. *)
  98. log error "non-privileged user."
  99. ;;
  100. esac
  101. }
  102. # cut out all comments(#) and blank lines from standard input
  103. meat() {
  104. grep -v -e "^[[:space:]]*#" -e '^$' "$1"
  105. }
  106. # cut a specified line from standard input
  107. cutline() {
  108. head --line="$1" "$2" | tail -1
  109. }
  110. # make a temporary directory
  111. msmktempdir() {
  112. mktemp -d ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  113. }
  114. # make a temporary file
  115. msmktempfile() {
  116. mktemp ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  117. }
  118. # this is a wrapper for doing lock functions.
  119. #
  120. # it lets us depend on either lockfile-progs (preferred) or procmail's
  121. # lockfile, and should
  122. lock() {
  123. local use_lockfileprogs=true
  124. local action="$1"
  125. local file="$2"
  126. if ! ( type lockfile-create &>/dev/null ) ; then
  127. if ! ( type lockfile &>/dev/null ); then
  128. failure "Neither lockfile-create nor lockfile are in the path!"
  129. fi
  130. use_lockfileprogs=
  131. fi
  132. case "$action" in
  133. create)
  134. if [ -n "$use_lockfileprogs" ] ; then
  135. lockfile-create "$file" || failure "unable to lock '$file'"
  136. else
  137. lockfile -r 20 "${file}.lock" || failure "unable to lock '$file'"
  138. fi
  139. log debug "lock created on '$file'."
  140. ;;
  141. touch)
  142. if [ -n "$use_lockfileprogs" ] ; then
  143. lockfile-touch --oneshot "$file"
  144. else
  145. : Nothing to do here
  146. fi
  147. log debug "lock touched on '$file'."
  148. ;;
  149. remove)
  150. if [ -n "$use_lockfileprogs" ] ; then
  151. lockfile-remove "$file"
  152. else
  153. rm -f "${file}.lock"
  154. fi
  155. log debug "lock removed on '$file'."
  156. ;;
  157. *)
  158. failure "bad argument for lock subfunction '$action'"
  159. esac
  160. }
  161. # for portability, between gnu date and BSD date.
  162. # arguments should be: number longunits format
  163. # e.g. advance_date 20 seconds +%F
  164. advance_date() {
  165. local gnutry
  166. local number="$1"
  167. local longunits="$2"
  168. local format="$3"
  169. local shortunits
  170. # try things the GNU way first
  171. if date -d "$number $longunits" "$format" &>/dev/null; then
  172. date -d "$number $longunits" "$format"
  173. else
  174. # otherwise, convert to (a limited version of) BSD date syntax:
  175. case "$longunits" in
  176. years)
  177. shortunits=y
  178. ;;
  179. months)
  180. shortunits=m
  181. ;;
  182. weeks)
  183. shortunits=w
  184. ;;
  185. days)
  186. shortunits=d
  187. ;;
  188. hours)
  189. shortunits=H
  190. ;;
  191. minutes)
  192. shortunits=M
  193. ;;
  194. seconds)
  195. shortunits=S
  196. ;;
  197. *)
  198. # this is a longshot, and will likely fail; oh well.
  199. shortunits="$longunits"
  200. esac
  201. date "-v+${number}${shortunits}" "$format"
  202. fi
  203. }
  204. # check that characters are in a string (in an AND fashion).
  205. # used for checking key capability
  206. # check_capability capability a [b...]
  207. check_capability() {
  208. local usage
  209. local capcheck
  210. usage="$1"
  211. shift 1
  212. for capcheck ; do
  213. if echo "$usage" | grep -q -v "$capcheck" ; then
  214. return 1
  215. fi
  216. done
  217. return 0
  218. }
  219. # hash of a file
  220. file_hash() {
  221. if type md5sum &>/dev/null ; then
  222. md5sum "$1"
  223. elif type md5 &>/dev/null ; then
  224. md5 "$1"
  225. else
  226. failure "Neither md5sum nor md5 are in the path!"
  227. fi
  228. }
  229. # convert escaped characters in pipeline from gpg output back into
  230. # original character
  231. # FIXME: undo all escape character translation in with-colons gpg
  232. # output
  233. gpg_unescape() {
  234. sed 's/\\x3a/:/g'
  235. }
  236. # convert nasty chars into gpg-friendly form in pipeline
  237. # FIXME: escape everything, not just colons!
  238. gpg_escape() {
  239. sed 's/:/\\x3a/g'
  240. }
  241. # prompt for GPG-formatted expiration, and emit result on stdout
  242. get_gpg_expiration() {
  243. local keyExpire
  244. keyExpire="$1"
  245. if [ -z "$keyExpire" -a "$PROMPT" != 'false' ]; then
  246. cat >&2 <<EOF
  247. Please specify how long the key should be valid.
  248. 0 = key does not expire
  249. <n> = key expires in n days
  250. <n>w = key expires in n weeks
  251. <n>m = key expires in n months
  252. <n>y = key expires in n years
  253. EOF
  254. while [ -z "$keyExpire" ] ; do
  255. printf "Key is valid for? (0) " >&2
  256. read keyExpire
  257. if ! test_gpg_expire ${keyExpire:=0} ; then
  258. echo "invalid value" >&2
  259. unset keyExpire
  260. fi
  261. done
  262. elif ! test_gpg_expire "$keyExpire" ; then
  263. failure "invalid key expiration value '$keyExpire'."
  264. fi
  265. echo "$keyExpire"
  266. }
  267. passphrase_prompt() {
  268. local prompt="$1"
  269. local fifo="$2"
  270. local PASS
  271. if [ "$DISPLAY" ] && type "${SSH_ASKPASS:-ssh-askpass}" >/dev/null 2>/dev/null; then
  272. printf 'Launching "%s"\n' "${SSH_ASKPASS:-ssh-askpass}" | log info
  273. printf '(with prompt "%s")\n' "$prompt" | log debug
  274. "${SSH_ASKPASS:-ssh-askpass}" "$prompt" > "$fifo"
  275. else
  276. read -s -p "$prompt" PASS
  277. # Uses the builtin echo, so should not put the passphrase into
  278. # the process table. I think. --dkg
  279. echo "$PASS" > "$fifo"
  280. fi
  281. }
  282. # remove all lines with specified string from specified file
  283. remove_line() {
  284. local file
  285. local string
  286. local tempfile
  287. file="$1"
  288. string="$2"
  289. if [ -z "$file" -o -z "$string" ] ; then
  290. return 1
  291. fi
  292. if [ ! -e "$file" ] ; then
  293. return 1
  294. fi
  295. # if the string is in the file...
  296. if grep "$string" "$file" &>/dev/null ; then
  297. tempfile=$(mktemp "${file}.XXXXXXX") || \
  298. failure "Unable to make temp file '${file}.XXXXXXX'"
  299. # remove the line with the string, and return 0
  300. grep -v "$string" "$file" >"$tempfile"
  301. mv -f "$tempfile" "$file"
  302. return 0
  303. # otherwise return 1
  304. else
  305. return 1
  306. fi
  307. }
  308. # remove all lines with MonkeySphere strings from stdin
  309. remove_monkeysphere_lines() {
  310. egrep -v ' MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2} '
  311. }
  312. # translate ssh-style path variables %h and %u
  313. translate_ssh_variables() {
  314. local uname
  315. local home
  316. uname="$1"
  317. path="$2"
  318. # get the user's home directory
  319. userHome=$(get_homedir "$uname")
  320. # translate '%u' to user name
  321. path=${path/\%u/"$uname"}
  322. # translate '%h' to user home directory
  323. path=${path/\%h/"$userHome"}
  324. echo "$path"
  325. }
  326. # test that a string to conforms to GPG's expiration format
  327. test_gpg_expire() {
  328. echo "$1" | egrep -q "^[0-9]+[mwy]?$"
  329. }
  330. # check that a file is properly owned, and that all it's parent
  331. # directories are not group/other writable
  332. check_key_file_permissions() {
  333. local uname
  334. local path
  335. uname="$1"
  336. path="$2"
  337. if [ "$STRICT_MODES" = 'false' ] ; then
  338. log debug "skipping path permission check for '$path' because STRICT_MODES is false..."
  339. return 0
  340. fi
  341. log debug "checking path permission '$path'..."
  342. "${SYSSHAREDIR}/checkperms" "$uname" "$path"
  343. }
  344. # return a list of all users on the system
  345. list_users() {
  346. if type getent &>/dev/null ; then
  347. # for linux and FreeBSD systems
  348. getent passwd | cut -d: -f1
  349. elif type dscl &>/dev/null ; then
  350. # for Darwin systems
  351. dscl localhost -list /Search/Users
  352. else
  353. failure "Neither getent or dscl is in the path! Could not determine list of users."
  354. fi
  355. }
  356. # take one argument, a service name. in response, print a series of
  357. # lines, each with a unique numeric port number that might be
  358. # associated with that service name. (e.g. in: "https", out: "443")
  359. # if nothing is found, print nothing, and return 0.
  360. #
  361. # return 1 if there was an error in the search somehow
  362. get_port_for_service() {
  363. [[ "$1" =~ ^[a-z0-9]([a-z0-9-]*[a-z0-9])?$ ]] || \
  364. failure $(printf "This is not a valid service name: '%s'" "$1")
  365. if type getent &>/dev/null ; then
  366. # for linux and FreeBSD systems (getent returns 2 if not found, 0 on success, 1 or 3 on various failures)
  367. (getent services "$service" || if [ "$?" -eq 2 ] ; then true ; else false; fi) | awk '{ print $2 }' | cut -f1 -d/ | sort -u
  368. elif [ -r /etc/services ] ; then
  369. # fall back to /etc/services for systems that don't have getent (MacOS?)
  370. # FIXME: doesn't handle aliases like "null" (or "http"?), which don't show up at the beginning of the line.
  371. awk $(printf '/^%s[[:space:]]/{ print $2 }' "$1") /etc/services | cut -f1 -d/ | sort -u
  372. else
  373. return 1
  374. fi
  375. }
  376. # return the path to the home directory of a user
  377. get_homedir() {
  378. local uname=${1:-`whoami`}
  379. eval "echo ~${uname}"
  380. }
  381. # return the primary group of a user
  382. get_primary_group() {
  383. local uname=${1:-`whoami`}
  384. groups "$uname" | sed 's/^..* : //' | awk '{ print $1 }'
  385. }
  386. ### CONVERSION UTILITIES
  387. # output the ssh key for a given key ID
  388. gpg2ssh() {
  389. local keyID
  390. keyID="$1"
  391. gpg --export --no-armor "$keyID" | openpgp2ssh "$keyID" 2>/dev/null
  392. }
  393. # output known_hosts line from ssh key
  394. ssh2known_hosts() {
  395. local host
  396. local port
  397. local key
  398. # FIXME this does not properly deal with IPv6 hosts using the
  399. # standard port (because it's unclear whether their final
  400. # colon-delimited address section is a port number or an address
  401. # string)
  402. host=${1%:*}
  403. port=${1##*:}
  404. key="$2"
  405. # specify the host and port properly for new ssh known_hosts
  406. # format
  407. if [ "$port" != "$host" ] ; then
  408. host="[${host}]:${port}"
  409. fi
  410. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  411. }
  412. # output authorized_keys line from ssh key
  413. ssh2authorized_keys() {
  414. local userID="$1"
  415. local key="$2"
  416. if [[ "$AUTHORIZED_KEYS_OPTIONS" ]]; then
  417. printf "%s %s MonkeySphere%s %s\n" "$AUTHORIZED_KEYS_OPTIONS" "$key" "$DATE" "$userID"
  418. else
  419. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  420. fi
  421. }
  422. # convert key from gpg to ssh known_hosts format
  423. gpg2known_hosts() {
  424. local host
  425. local keyID
  426. local key
  427. host="$1"
  428. keyID="$2"
  429. key=$(gpg2ssh "$keyID")
  430. # NOTE: it seems that ssh-keygen -R removes all comment fields from
  431. # all lines in the known_hosts file. why?
  432. # NOTE: just in case, the COMMENT can be matched with the
  433. # following regexp:
  434. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  435. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  436. }
  437. # convert key from gpg to ssh authorized_keys format
  438. gpg2authorized_keys() {
  439. local userID
  440. local keyID
  441. local key
  442. userID="$1"
  443. keyID="$2"
  444. key=$(gpg2ssh "$keyID")
  445. # NOTE: just in case, the COMMENT can be matched with the
  446. # following regexp:
  447. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  448. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  449. }
  450. ### GPG UTILITIES
  451. # script to determine if gpg version is equal to or greater than specified version
  452. is_gpg_version_greater_equal() {
  453. local gpgVersion=$(gpg --version | head -1 | awk '{ print $3 }')
  454. local latest=$(printf '%s\n%s\n' "$1" "$gpgVersion" \
  455. | tr '.' ' ' | sort -g -k1 -k2 -k3 \
  456. | tail -1 | tr ' ' '.')
  457. [[ "$gpgVersion" == "$latest" ]]
  458. }
  459. # retrieve all keys with given user id from keyserver
  460. # FIXME: need to figure out how to retrieve all matching keys
  461. # (not just first N (5 in this case))
  462. gpg_fetch_userid() {
  463. local returnCode=0
  464. local userID
  465. if [ "$CHECK_KEYSERVER" != 'true' ] ; then
  466. return 0
  467. fi
  468. userID="$1"
  469. log verbose " checking keyserver $KEYSERVER... "
  470. echo 1,2,3,4,5 | \
  471. gpg --quiet --batch --with-colons \
  472. --command-fd 0 --keyserver "$KEYSERVER" \
  473. --search ="$userID" &>/dev/null
  474. returnCode="$?"
  475. if [ "$returnCode" != 0 ] ; then
  476. log error "Failure ($returnCode) searching keyserver $KEYSERVER for user id '$userID'"
  477. fi
  478. return "$returnCode"
  479. }
  480. ########################################################################
  481. ### PROCESSING FUNCTIONS
  482. # userid and key policy checking
  483. # the following checks policy on the returned keys
  484. # - checks that full key has appropriate valididy (u|f)
  485. # - checks key has specified capability (REQUIRED_KEY_CAPABILITY)
  486. # - checks that requested user ID has appropriate validity
  487. # (see /usr/share/doc/gnupg/DETAILS.gz)
  488. # output is one line for every found key, in the following format:
  489. #
  490. # flag:sshKey
  491. #
  492. # "flag" is an acceptability flag, 0 = ok, 1 = bad
  493. # "sshKey" is the relevant OpenPGP key, in the form accepted by OpenSSH
  494. #
  495. # all log output must go to stderr, as stdout is used to pass the
  496. # flag:sshKey to the calling function.
  497. process_user_id() {
  498. local returnCode=0
  499. local userID="$1"
  500. local requiredCapability
  501. local requiredPubCapability
  502. local gpgOut
  503. local type
  504. local validity
  505. local keyid
  506. local uidfpr
  507. local usage
  508. local keyOK
  509. local uidOK
  510. local lastKey
  511. local lastKeyOK
  512. local fingerprint
  513. # set the required key capability based on the mode
  514. requiredCapability=${REQUIRED_KEY_CAPABILITY:="a"}
  515. requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
  516. # fetch the user ID if necessary/requested
  517. gpg_fetch_userid "$userID"
  518. # output gpg info for (exact) userid and store
  519. gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
  520. --with-fingerprint --with-fingerprint \
  521. ="$userID" 2>/dev/null) || returnCode="$?"
  522. # if the gpg query return code is not 0, return 1
  523. if [ "$returnCode" -ne 0 ] ; then
  524. log verbose " no primary keys found."
  525. return 1
  526. fi
  527. # loop over all lines in the gpg output and process.
  528. echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
  529. while IFS=: read -r type validity keyid uidfpr usage ; do
  530. # process based on record type
  531. case $type in
  532. 'pub') # primary keys
  533. # new key, wipe the slate
  534. keyOK=
  535. uidOK=
  536. lastKey=pub
  537. lastKeyOK=
  538. fingerprint=
  539. log verbose " primary key found: $keyid"
  540. # if overall key is not valid, skip
  541. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  542. log debug " - unacceptable primary key validity ($validity)."
  543. continue
  544. fi
  545. # if overall key is disabled, skip
  546. if check_capability "$usage" 'D' ; then
  547. log debug " - key disabled."
  548. continue
  549. fi
  550. # if overall key capability is not ok, skip
  551. if ! check_capability "$usage" $requiredPubCapability ; then
  552. log debug " - unacceptable primary key capability ($usage)."
  553. continue
  554. fi
  555. # mark overall key as ok
  556. keyOK=true
  557. # mark primary key as ok if capability is ok
  558. if check_capability "$usage" $requiredCapability ; then
  559. lastKeyOK=true
  560. fi
  561. ;;
  562. 'uid') # user ids
  563. if [ "$lastKey" != pub ] ; then
  564. log verbose " ! got a user ID after a sub key?! user IDs should only follow primary keys!"
  565. continue
  566. fi
  567. # if an acceptable user ID was already found, skip
  568. if [ "$uidOK" = 'true' ] ; then
  569. continue
  570. fi
  571. # if the user ID does matches...
  572. if [ "$(echo "$uidfpr" | gpg_unescape)" = "$userID" ] ; then
  573. # and the user ID validity is ok
  574. if [ "$validity" = 'u' -o "$validity" = 'f' ] ; then
  575. # mark user ID acceptable
  576. uidOK=true
  577. else
  578. log debug " - unacceptable user ID validity ($validity)."
  579. fi
  580. else
  581. continue
  582. fi
  583. # output a line for the primary key
  584. # 0 = ok, 1 = bad
  585. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  586. log verbose " * acceptable primary key."
  587. if [ -z "$sshKey" ] ; then
  588. log verbose " ! primary key could not be translated (not RSA?)."
  589. else
  590. echo "0:${sshKey}"
  591. fi
  592. else
  593. log debug " - unacceptable primary key."
  594. if [ -z "$sshKey" ] ; then
  595. log debug " ! primary key could not be translated (not RSA?)."
  596. else
  597. echo "1:${sshKey}"
  598. fi
  599. fi
  600. ;;
  601. 'sub') # sub keys
  602. # unset acceptability of last key
  603. lastKey=sub
  604. lastKeyOK=
  605. fingerprint=
  606. # don't bother with sub keys if the primary key is not valid
  607. if [ "$keyOK" != true ] ; then
  608. continue
  609. fi
  610. # don't bother with sub keys if no user ID is acceptable:
  611. if [ "$uidOK" != true ] ; then
  612. continue
  613. fi
  614. # if sub key validity is not ok, skip
  615. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  616. log debug " - unacceptable sub key validity ($validity)."
  617. continue
  618. fi
  619. # if sub key capability is not ok, skip
  620. if ! check_capability "$usage" $requiredCapability ; then
  621. log debug " - unacceptable sub key capability ($usage)."
  622. continue
  623. fi
  624. # mark sub key as ok
  625. lastKeyOK=true
  626. ;;
  627. 'fpr') # key fingerprint
  628. fingerprint="$uidfpr"
  629. sshKey=$(gpg2ssh "$fingerprint")
  630. # if the last key was the pub key, skip
  631. if [ "$lastKey" = pub ] ; then
  632. continue
  633. fi
  634. # output a line for the sub key
  635. # 0 = ok, 1 = bad
  636. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  637. log verbose " * acceptable sub key."
  638. if [ -z "$sshKey" ] ; then
  639. log error " ! sub key could not be translated (not RSA?)."
  640. else
  641. echo "0:${sshKey}"
  642. fi
  643. else
  644. log debug " - unacceptable sub key."
  645. if [ -z "$sshKey" ] ; then
  646. log debug " ! sub key could not be translated (not RSA?)."
  647. else
  648. echo "1:${sshKey}"
  649. fi
  650. fi
  651. ;;
  652. esac
  653. done | sort -t: -k1 -n -r
  654. # NOTE: this last sort is important so that the "good" keys (key
  655. # flag '0') come last. This is so that they take precedence when
  656. # being processed in the key files over "bad" keys (key flag '1')
  657. }
  658. process_keys_for_file() {
  659. local keyFile="$1"
  660. local userID="$2"
  661. local host
  662. local ok
  663. local sshKey
  664. local noKey=
  665. log verbose "processing: $userID"
  666. log debug "key file: $keyFile"
  667. IFS=$'\n'
  668. for line in $(process_user_id "$userID") ; do
  669. ok=${line%%:*}
  670. sshKey=${line#*:}
  671. if [ -z "$sshKey" ] ; then
  672. continue
  673. fi
  674. # remove the old host key line
  675. if [[ "$keyFile" != '-' ]] ; then
  676. case "$FILE_TYPE" in
  677. ('authorized_keys')
  678. remove_line "$keyFile" "$sshKey" || noKey=true
  679. ;;
  680. ('known_hosts')
  681. host=${userID#ssh://}
  682. remove_line "$keyFile" "${host}.*${sshKey}" || noKey=true
  683. ;;
  684. esac
  685. fi
  686. # if key OK, add new host line
  687. if [ "$ok" -eq '0' ] ; then
  688. case "$FILE_TYPE" in
  689. ('raw')
  690. echo "$sshKey" | log debug
  691. if [[ "$keyFile" == '-' ]] ; then
  692. echo "$sshKey"
  693. else
  694. echo "$sshKey" >>"$keyFile"
  695. fi
  696. ;;
  697. ('authorized_keys')
  698. ssh2authorized_keys "$userID" "$sshKey" | log debug
  699. if [[ "$keyFile" == '-' ]] ; then
  700. ssh2authorized_keys "$userID" "$sshKey"
  701. else
  702. ssh2authorized_keys "$userID" "$sshKey" >> "$keyFile"
  703. fi
  704. ;;
  705. ('known_hosts')
  706. host=${userID#ssh://}
  707. ssh2known_hosts "$host" "$sshKey" | log debug
  708. # hash if specified
  709. if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
  710. if (type ssh-keygen >/dev/null) ; then
  711. # FIXME: this is really hackish cause
  712. # ssh-keygen won't hash from stdin to
  713. # stdout
  714. tmpfile=$(mktemp ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
  715. ssh2known_hosts "$host" "$sshKey" \
  716. > "$tmpfile"
  717. ssh-keygen -H -f "$tmpfile" 2>/dev/null
  718. if [[ "$keyFile" == '-' ]] ; then
  719. cat "$tmpfile"
  720. else
  721. cat "$tmpfile" >> "$keyFile"
  722. fi
  723. rm -f "$tmpfile" "${tmpfile}.old"
  724. # FIXME: we could do this without needing
  725. # ssh-keygen. hashed known_hosts looks
  726. # like: |1|X|Y where 1 means SHA1 (nothing
  727. # else is defined in openssh sources), X
  728. # is the salt (same length as the digest
  729. # output), base64-encoded, and Y is the
  730. # digested hostname (also base64-encoded).
  731. # see hostfile.{c,h} in openssh sources.
  732. else
  733. failure "Cannot hash known_hosts as requested"
  734. fi
  735. # log if this is a new key to the known_hosts file
  736. if [ "$noKey" ] ; then
  737. log info "* new key will be added to known_hosts file."
  738. fi
  739. else
  740. if [[ "$keyFile" == '-' ]] ; then
  741. ssh2known_hosts "$host" "$sshKey"
  742. else
  743. ssh2known_hosts "$host" "$sshKey" >>"$keyFile"
  744. fi
  745. fi
  746. ;;
  747. esac
  748. fi
  749. done
  750. }
  751. # process an authorized_user_ids file on stdin for authorized_keys
  752. process_authorized_user_ids() {
  753. local authorizedKeys="$1"
  754. declare -i nline=0
  755. local line
  756. declare -a userIDs
  757. declare -a koptions
  758. # extract user IDs from authorized_user_ids file
  759. IFS=$'\n'
  760. while read line ; do
  761. case "$line" in
  762. ("#"*)
  763. continue
  764. ;;
  765. (" "*|$'\t'*)
  766. if [[ -z ${koptions[${nline}]} ]]; then
  767. koptions[${nline}]=$(echo $line | sed 's/^[ ]*//;s/[ ]$//;')
  768. else
  769. koptions[${nline}]="${koptions[${nline}]},$(echo $line | sed 's/^[ ]*//;s/[ ]$//;')"
  770. fi
  771. ;;
  772. (*)
  773. ((nline++))
  774. userIDs[${nline}]="$line"
  775. unset koptions[${nline}] || true
  776. ;;
  777. esac
  778. done
  779. for i in $(seq 1 $nline); do
  780. AUTHORIZED_KEYS_OPTIONS="${koptions[$i]}" FILE_TYPE='authorized_keys' process_keys_for_file "$authorizedKeys" "${userIDs[$i]}" || returnCode="$?"
  781. done
  782. }
  783. # takes a gpg key or keys on stdin, and outputs a list of
  784. # fingerprints, one per line:
  785. list_primary_fingerprints() {
  786. local fake=$(msmktempdir)
  787. trap "rm -rf $fake" EXIT
  788. GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
  789. GNUPGHOME="$fake" gpg --with-colons --fingerprint --list-keys | \
  790. awk -F: '/^fpr:/{ print $10 }'
  791. trap - EXIT
  792. rm -rf "$fake"
  793. }
  794. # takes an OpenPGP key or set of keys on stdin, a fingerprint or other
  795. # key identifier as $1, and outputs the gpg-formatted information for
  796. # the requested keys from the material on stdin
  797. get_cert_info() {
  798. local fake=$(msmktempdir)
  799. trap "rm -rf $fake" EXIT
  800. GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
  801. GNUPGHOME="$fake" gpg --with-colons --fingerprint --fixed-list-mode --list-keys "$1"
  802. trap - EXIT
  803. rm -rf "$fake"
  804. }
  805. check_cruft_file() {
  806. local loc="$1"
  807. local version="$2"
  808. if [ -e "$loc" ] ; then
  809. printf "! The file '%s' is no longer used by\n monkeysphere (as of version %s), and can be removed.\n\n" "$loc" "$version" | log info
  810. fi
  811. }
  812. check_upgrade_dir() {
  813. local loc="$1"
  814. local version="$2"
  815. if [ -d "$loc" ] ; then
  816. printf "The presence of directory '%s' indicates that you have\nnot yet completed a monkeysphere upgrade.\nYou should probably run the following script:\n %s/transitions/%s\n\n" "$loc" "$SYSSHAREDIR" "$version" | log info
  817. fi
  818. }
  819. ## look for cruft from old versions of the monkeysphere, and notice if
  820. ## upgrades have not been run:
  821. report_cruft() {
  822. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-host" 0.23
  823. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-authentication" 0.23
  824. check_cruft_file "${SYSCONFIGDIR}/gnupg-authentication.conf" 0.23
  825. check_cruft_file "${SYSCONFIGDIR}/gnupg-host.conf" 0.23
  826. local found=
  827. for foo in "${SYSDATADIR}/backup-from-"*"-transition" ; do
  828. if [ -d "$foo" ] ; then
  829. printf "! %s\n" "$foo" | log info
  830. found=true
  831. fi
  832. done
  833. if [ "$found" ] ; then
  834. printf "The directories above are backups left over from a monkeysphere transition.\nThey may contain copies of sensitive data (host keys, certifier lists), but\nthey are no longer needed by monkeysphere.\nYou may remove them at any time.\n\n" | log info
  835. fi
  836. }